//
//  CommunicationAuthentication.h
//  Fuze
//
//  Created by Ivan Shulev on 6/29/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#if FUZE_MAC_BUILD
#import <FZHTTPMessage.h>
#import <FZHTTPAuthentication.h>
#else
#define FZHTTPMessageRef CFHTTPMessageRef
#endif //FUZE_MAC_BUILD


@interface CommunicationAuthentication : NSObject
{
    NSString* _hostname;

    NSURL* _url;
    NSURL* _urlWithoutSchema;

    FZHTTPAuthenticationRef _authentication;
    FZHTTPMessageRef _requestMessage;

    CFStringRef _username;
    CFStringRef _password;
    CFStringRef _domain;

    CFMutableDictionaryRef _credentials;

    BOOL isInitialClientRequestSent;

    BOOL _connectionDroppedByProxy;

    BOOL _isBadCredentials;

    NSData* _lastData;

    NSString* proxyAddress;
}

@property (retain) NSString* proxyAddress;

- (id) initWithHostname: (NSString*) hostname
                andPort: (unsigned short) port;

- (NSString*) startHttpConnectString;

- (int) processResponseData: (NSData*) responseData;

- (NSData*) requestData;

- (void) authenticationSucceeded;

@end
