//
//  NtlmAuthentication.h
//  asynctransport
//
//  Created by Ivan Shulev on 7/17/12.
//  Copyright (c) 2012 FuzeBox, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CommunicationAuthentication.h"


@interface NtlmAuthentication : NSObject
{
    NSString* _hostname;
    NSString* _port;
    NSString* _proxyHostnamePort;
    
    CommunicationAuthentication* _authentication;
}


- (id) initWithHostname: (const char*) hostname
                andPort: (const char*) port
   andProxyHostnamePort: (const char*) proxyHostnamePort;

- (const char*) createRequestNegotiation;

- (const char*) createNextRequestNegotiationUsingChallenge: (const char*) challenge;

- (NSString*) retrieveNtlmHashFrom: (NSString*) httpMessageString;

- (void) releaseChars:(const char*) str;

@end
