//
//  ProxyChangesListener.h
//  Fuze
//
//  Created by Ivan Shulev on 12/19/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "ProxySettings.h"

#import <Foundation/Foundation.h>
#import <SystemConfiguration/SystemConfiguration.h>


static void CFReleaseIfNotNULL(CFTypeRef typeRef);


@interface ProxyChangesListener : NSObject
{
    CFDictionaryRef proxyDictionary;

    CFStringRef destinationURL;

    CFArrayRef proxiesToTry;

    NSCondition* proxyChangesListenerLock;
}

+ (ProxyChangesListener*) instance;

@property (assign) CFDictionaryRef proxyDictionary;

@property (readonly) CFStringRef destinationURL;

@property (readonly) CFArrayRef proxiesToTry;

- (ProxySettings*) firstProxy;

- (void) resolveProxies;

- (void) dispatchLogoutEvent;

@end
